﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Combinator
{
    public class ConsoleLogger : ILogger
    {
        private ILogger logger = new TextWriterLogger() { Writer = Console.Out };

        public void Write(int level, object[] messages)
        {
            switch (level)
            {
                case Logger.DetailInformation:
                case Logger.Information:
                    Console.ForegroundColor = ConsoleColor.Gray;
                    break;
                case Logger.Warning:
                    Console.ForegroundColor = ConsoleColor.Yellow;
                    break;
                case Logger.Error:
                case Logger.FatalError:
                    Console.ForegroundColor = ConsoleColor.Red;
                    break;
            }
            this.logger.Write(level, messages);
        }
    }
}