﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Combinator
{
    public class ExceptionLogger : ILogger
    {
        public bool PrintInnerException { get; set; }
        public bool PrintStackTrace { get; set; }
        public ILogger Logger { get; set; }

        private object Translate(object message)
        {
            Exception ex = message as Exception;
            if (ex != null)
            {
                List<Exception> exs = new List<Exception> { ex };
                if (this.PrintInnerException)
                {
                    ex = ex.InnerException;
                    while (ex != null)
                    {
                        exs.Insert(0, ex);
                        ex = ex.InnerException;
                    }
                }

                if (this.PrintStackTrace)
                {
                    return exs.Aggregate("", (s, e) => s + e.Message + "\r\n" + e.StackTrace + "\r\n\r\n");
                }
                else
                {
                    return exs.Aggregate("", (s, e) => s + e.Message + "\r\n");
                }
            }
            else
            {
                return message;
            }
        }

        public void Write(int level, object[] messages)
        {
            this.Logger.Write(level, messages.Select(Translate).ToArray());
        }
    }
}
