﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Combinator;
using InformationGenerator;

namespace Demo
{
    class Program
    {
        static void Main(string[] args)
        {
            string path = typeof(Program).Assembly.Location;
            string folder = Path.GetDirectoryName(path);
            string logFile = folder + "\\buildchk.log";
            string warningFile = folder + "\\buildchk.wrn";
            string errorFile = folder + "\\buildchk.err";

            using (StreamWriter logWriter = new StreamWriter(logFile))
            using (StreamWriter warningWriter = new StreamWriter(warningFile))
            using (StreamWriter errorWriter = new StreamWriter(errorFile))
            {
                ILogger logger = Logger.Sequence(
                    Logger.WriteTo(logWriter)
                        .WithTimestamp()
                        .WithExceptionDetail(printInnerException: true, printStackTrace: true),

                    Logger.WriteTo(warningWriter)
                        .AcceptLevel(Logger.Warning),

                    Logger.WriteTo(errorWriter)
                        .AcceptLevel(Logger.Error),

                    Logger.WriteToConsole()
                        .WithExceptionDetail(printInnerException: false, printStackTrace: false)
                        .RejectLevel(Logger.DetailInformation)
                    );

                LogGenerator.Generate(logger);
            }
            Console.ReadKey();
        }
    }
}
