﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Combinator;
using System.IO;
using System.Threading;

namespace InformationGenerator
{
    public static class LogGenerator
    {
        public static void Generate(ILogger logger)
        {
            string path = typeof(LogGenerator).Assembly.Location;
            string folder = Path.GetDirectoryName(path);
            string dataFile = folder + "\\Data.txt";
            Random r = new Random();
            using (StreamReader reader = new StreamReader(dataFile))
            {
                while (!reader.EndOfStream)
                {
                    Thread.Sleep(r.Next(50, 150));
                    string line = reader.ReadLine();
                    if (line.StartsWith("INFORMATION>"))
                    {
                        logger.WriteInformation(line.Substring(12));
                    }
                    else if (line.StartsWith("DETAIL>"))
                    {
                        logger.WriteDetailInformation(line.Substring(7));
                    }
                    else if (line.StartsWith("WARNING>"))
                    {
                        logger.WriteWarning(line.Substring(8));
                    }
                    else if (line.StartsWith("ERROR>"))
                    {
                        logger.WriteError(line.Substring(6));
                    }
                    else if (line.StartsWith("EXCEPTION>"))
                    {
                        try
                        {
                            throw new Exception(line.Substring(10));
                        }
                        catch (Exception ex)
                        {
                            logger.WriteException(ex);
                        }
                    }
                    else
                    {
                        throw new Exception("Unable to process message: " + line);
                    }
                }
            }
        }
    }
}
